package cz.mendelu.dnaAnalyser.batch;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import cz.mendelu.dnaAnalyser.user.User;
import cz.mendelu.dnaAnalyser.utils.model.Owned;
import lombok.AccessLevel;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;
import java.util.UUID;

import static com.fasterxml.jackson.annotation.JsonInclude.Include.NON_NULL;

/**
 * Created by Jan Kolomazník on 22.6.17.
 */
@Data
@Entity
@JsonInclude(NON_NULL)
@IdClass(Batch.CompositeId.class)
@Table(name = "batchs")
public class Batch implements Owned {

    public enum Status {
        CREATED, WAITING, RUNNING, FINISH, FAILED
    }

    @Data
    static class CompositeId implements Serializable {
        private String entityClass;
        private UUID entityId;
    }

    @Id
    @JsonIgnore
    private String entityClass;

    @Id
    @JsonIgnore
    private UUID entityId;

    @ManyToOne(cascade = CascadeType.DETACH)
    @JsonIgnore
    private User owner;

    private String name;

    private Status status;

    private Date created;

    private Date finished;

    private  Date started;

    private Double progress;

    private String exception;

    private Long cpuTime;

}
