package cz.mendelu.dnaAnalyser.sequence

import cz.mendelu.dnaAnalyser.sequence.ModelSequenceService
import cz.mendelu.dnaAnalyser.utils.exception.NotFoundException
import cz.mendelu.dnaAnalyser.sequence.Sequence
import cz.mendelu.dnaAnalyser.sequence.data.*
import spock.lang.Specification

class BufferSequenceDataServiceTest extends Specification {

    BufferSequenceDataService bufferSequenceService

    ModelSequenceService modelSequenceService
    SequenceDataRepository sequenceBufferRepository

    UUID sequenceId = UUID.randomUUID()
    UUID bufferId = UUID.randomUUID()
    Sequence sequence = new Sequence(
            id: sequenceId,
            bufferId: bufferId
    )

    def setup() {
        bufferSequenceService = new BufferSequenceDataService()
        bufferSequenceService.modelSequenceService = modelSequenceService = Mock(ModelSequenceService)
        bufferSequenceService.sequenceDataRepository = sequenceBufferRepository = Mock(SequenceDataRepository)
    }

    def "test findSequenceBuffer"() {
        when:
        bufferSequenceService.findSequenceBuffer(sequenceId)

        then:
        1 * modelSequenceService.findOne(sequenceId) >> sequence
        1 * sequenceBufferRepository.load(sequence)
    }

    def "test findSequenceBuffer another user"() {
        when:
        bufferSequenceService.findSequenceBuffer(sequenceId)

        then:
        1 * modelSequenceService.findOne(sequenceId) >> null
        thrown(NotFoundException)
    }
}
