package cz.mendelu.dnaAnalyser.sequence.data

import cz.mendelu.dnaAnalyser.sequence.Sequence
import cz.mendelu.dnaAnalyser.sequence.SequenceType
import cz.mendelu.dnaAnalyser.sequence.nucleotide.Nucleotide
import cz.mendelu.dnaAnalyser.user.User
import spock.lang.Specification

class SequenceDataTest extends Specification {

    def "test Mutation"() {

        given:
        def sequence = new Sequence(
                id: UUID.randomUUID(),
                name: 'ImportPlainFormat',
                type: SequenceType.DNA,
                circular: false,
                owner: new User()
        )
        def data = SequenceData.wrap(sequence, "ACTG".bytes)
        when:
        def mutated=data.mutation(0, Nucleotide.N)
        then:
        data.get(0) == Nucleotide.A
        mutated.get(0) == Nucleotide.N
    }

    //todo add test that test if all methods work even if buffer is done on mapped file
}
